> This page is for Paperwork API, version v2.
> For other versions, use one of these documentation indexes:
> - v1 (default): https://docs.cloudraker.com/paperwork/v1/llms.txt

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.cloudraker.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.cloudraker.com/_mcp/server.

# Edit the document

POST https://your-org.cloudraker.run/v2/redline/{id}/edits
Content-Type: application/json

Reference: https://docs.cloudraker.com/paperwork/v2/api/redline/edit

## Authentication

- `Authorization` header (bearer token, required) — An API key (`crk_`), an exchanged token (`crt_`) or a JWT of a trusted issuer. The credential needs the scope of the capability. Read the description of each route.

## Request

### Path parameters

- `id` (string, required) — The id of the session.

### Body (application/json)

This endpoint expects a RedlineEditRequest.

- `RedlineEditRequest`
  - RedlineEditReplace: RedlineEditReplace
  - RedlineEditInsert: RedlineEditInsert
  - RedlineEditFill: RedlineEditFill
  - RedlineEditDelete: RedlineEditDelete

## Response

### 200

The edit.

- `revision` (integer, required)
- `result` (RedlineEditOutcome, required) — What an edit changed.
- `summary` (RedlineSummary, required) — The counts of a session.

## Errors

### 400 Bad Request Error

An error. The `code` is one of: `invalid_request`, `wait_out_of_range`, `deadline_not_supported`, `procedure_invalid`.

- `code` (enum, required) — The error code.
  - Allowed values: `invalid_request`, `wait_out_of_range`, `deadline_not_supported`, `procedure_invalid`, `missing_credential`, `invalid_api_key`, `invalid_token`, `credits_exhausted`, `insufficient_scope`, `production_access_disabled`, `test_key_not_allowed`, `not_found`, `tenant_not_found`, `job_not_found`, `idempotency_key_reused`, `job_not_cancellable`, `version_conflict`, `not_waiting`, `rate_limit_exceeded`, `concurrency_limited`, `internal_error`, `capability_unavailable`
- `message` (string, required) — A text for the developer. Do not parse it.
- `retryable` (boolean, required) — True when the same request can succeed later.
- `requestId` (string, required) — The value of the `x-request-id` answer header.
- `docUrl` (string, optional) — The docs page of this code.
- `details` (any, optional) — The validation issues of `invalid_request`.

### 401 Unauthorized Error

An error. The `code` is one of: `missing_credential`, `invalid_api_key`, `invalid_token`.

- `code` (enum, required) — The error code.
  - Allowed values: `invalid_request`, `wait_out_of_range`, `deadline_not_supported`, `procedure_invalid`, `missing_credential`, `invalid_api_key`, `invalid_token`, `credits_exhausted`, `insufficient_scope`, `production_access_disabled`, `test_key_not_allowed`, `not_found`, `tenant_not_found`, `job_not_found`, `idempotency_key_reused`, `job_not_cancellable`, `version_conflict`, `not_waiting`, `rate_limit_exceeded`, `concurrency_limited`, `internal_error`, `capability_unavailable`
- `message` (string, required) — A text for the developer. Do not parse it.
- `retryable` (boolean, required) — True when the same request can succeed later.
- `requestId` (string, required) — The value of the `x-request-id` answer header.
- `docUrl` (string, optional) — The docs page of this code.
- `details` (any, optional) — The validation issues of `invalid_request`.

### 403 Forbidden Error

An error. The `code` is one of: `insufficient_scope`, `production_access_disabled`, `test_key_not_allowed`.

- `code` (enum, required) — The error code.
  - Allowed values: `invalid_request`, `wait_out_of_range`, `deadline_not_supported`, `procedure_invalid`, `missing_credential`, `invalid_api_key`, `invalid_token`, `credits_exhausted`, `insufficient_scope`, `production_access_disabled`, `test_key_not_allowed`, `not_found`, `tenant_not_found`, `job_not_found`, `idempotency_key_reused`, `job_not_cancellable`, `version_conflict`, `not_waiting`, `rate_limit_exceeded`, `concurrency_limited`, `internal_error`, `capability_unavailable`
- `message` (string, required) — A text for the developer. Do not parse it.
- `retryable` (boolean, required) — True when the same request can succeed later.
- `requestId` (string, required) — The value of the `x-request-id` answer header.
- `docUrl` (string, optional) — The docs page of this code.
- `details` (any, optional) — The validation issues of `invalid_request`.

### 404 Not Found Error

An error. The `code` is one of: `not_found`, `tenant_not_found`, `job_not_found`.

- `code` (enum, required) — The error code.
  - Allowed values: `invalid_request`, `wait_out_of_range`, `deadline_not_supported`, `procedure_invalid`, `missing_credential`, `invalid_api_key`, `invalid_token`, `credits_exhausted`, `insufficient_scope`, `production_access_disabled`, `test_key_not_allowed`, `not_found`, `tenant_not_found`, `job_not_found`, `idempotency_key_reused`, `job_not_cancellable`, `version_conflict`, `not_waiting`, `rate_limit_exceeded`, `concurrency_limited`, `internal_error`, `capability_unavailable`
- `message` (string, required) — A text for the developer. Do not parse it.
- `retryable` (boolean, required) — True when the same request can succeed later.
- `requestId` (string, required) — The value of the `x-request-id` answer header.
- `docUrl` (string, optional) — The docs page of this code.
- `details` (any, optional) — The validation issues of `invalid_request`.

### 429 Too Many Requests Error

An error. The `code` is one of: `rate_limit_exceeded`, `concurrency_limited`.

- `code` (enum, required) — The error code.
  - Allowed values: `invalid_request`, `wait_out_of_range`, `deadline_not_supported`, `procedure_invalid`, `missing_credential`, `invalid_api_key`, `invalid_token`, `credits_exhausted`, `insufficient_scope`, `production_access_disabled`, `test_key_not_allowed`, `not_found`, `tenant_not_found`, `job_not_found`, `idempotency_key_reused`, `job_not_cancellable`, `version_conflict`, `not_waiting`, `rate_limit_exceeded`, `concurrency_limited`, `internal_error`, `capability_unavailable`
- `message` (string, required) — A text for the developer. Do not parse it.
- `retryable` (boolean, required) — True when the same request can succeed later.
- `requestId` (string, required) — The value of the `x-request-id` answer header.
- `docUrl` (string, optional) — The docs page of this code.
- `details` (any, optional) — The validation issues of `invalid_request`.

### 500 Internal Server Error

An error. The `code` is one of: `internal_error`.

- `code` (enum, required) — The error code.
  - Allowed values: `invalid_request`, `wait_out_of_range`, `deadline_not_supported`, `procedure_invalid`, `missing_credential`, `invalid_api_key`, `invalid_token`, `credits_exhausted`, `insufficient_scope`, `production_access_disabled`, `test_key_not_allowed`, `not_found`, `tenant_not_found`, `job_not_found`, `idempotency_key_reused`, `job_not_cancellable`, `version_conflict`, `not_waiting`, `rate_limit_exceeded`, `concurrency_limited`, `internal_error`, `capability_unavailable`
- `message` (string, required) — A text for the developer. Do not parse it.
- `retryable` (boolean, required) — True when the same request can succeed later.
- `requestId` (string, required) — The value of the `x-request-id` answer header.
- `docUrl` (string, optional) — The docs page of this code.
- `details` (any, optional) — The validation issues of `invalid_request`.

### 503 Service Unavailable Error

An error. The `code` is one of: `capability_unavailable`.

- `code` (enum, required) — The error code.
  - Allowed values: `invalid_request`, `wait_out_of_range`, `deadline_not_supported`, `procedure_invalid`, `missing_credential`, `invalid_api_key`, `invalid_token`, `credits_exhausted`, `insufficient_scope`, `production_access_disabled`, `test_key_not_allowed`, `not_found`, `tenant_not_found`, `job_not_found`, `idempotency_key_reused`, `job_not_cancellable`, `version_conflict`, `not_waiting`, `rate_limit_exceeded`, `concurrency_limited`, `internal_error`, `capability_unavailable`
- `message` (string, required) — A text for the developer. Do not parse it.
- `retryable` (boolean, required) — True when the same request can succeed later.
- `requestId` (string, required) — The value of the `x-request-id` answer header.
- `docUrl` (string, optional) — The docs page of this code.
- `details` (any, optional) — The validation issues of `invalid_request`.

## Types

### RedlineEditReplace

Replace matched text.

- `op` ("replace", required)
- `anchorText` (string, required) — The text to find.
- `replacement` (string, required)
- `occurrence` (integer, optional) — Which match to use, 1-based.
- `all` (boolean, optional) — True to act on every match.
- `tracked` (boolean, optional) — False applies the edit with no tracked change. Default true.
- `author` (string, optional) — The author of the tracked change.

### RedlineEditInsert

Insert Markdown blocks.

- `op` ("insertMarkdown", required)
- `markdown` (string, required)
- `position` (enum, required)
  - Allowed values: `before`, `after`, `end`
- `anchorText` (string, optional) — Required for before and after.
- `occurrence` (integer, optional) — Which match to use, 1-based.
- `tracked` (boolean, optional) — False applies the edit with no tracked change. Default true.
- `author` (string, optional) — The author of the tracked change.

### RedlineEditFill

Fill several placeholders in one revision.

- `op` ("fill", required)
- `fields` (list of RedlineEditFillFieldsItems, required)
- `tracked` (boolean, optional) — False applies the edit with no tracked change. Default true.
- `author` (string, optional) — The author of the tracked change.

### RedlineEditDelete

Delete matched text.

- `op` ("deleteText", required)
- `anchorText` (string, required) — The text to find.
- `occurrence` (integer, optional) — Which match to use, 1-based.
- `all` (boolean, optional) — True to act on every match.
- `tracked` (boolean, optional) — False applies the edit with no tracked change. Default true.
- `author` (string, optional) — The author of the tracked change.

### RedlineEditOutcome

What an edit changed.

- `op` (string, required)
- `replacements` (integer, required)
- `blocksInserted` (integer, required)
- `blockIds` (list of string, required)
- `trackedChangeIds` (list of string, required) — Valid only at the revision of this answer. Read the suggestions again before you accept or reject.

### RedlineSummary

The counts of a session.

- `paragraphCount` (integer, required)
- `comments` (integer, required)
- `trackedChanges` (integer, required)

### RedlineEditFillFieldsItems

- `anchorText` (string, required) — The text to find.
- `replacement` (string, required)
- `occurrence` (integer, optional) — Which match to use, 1-based.
- `all` (boolean, optional) — True to act on every match.

## Examples

**Request**

```json
{
  "anchorText": "string",
  "op": "string",
  "replacement": "string"
}
```

**Response**

```json
{
  "revision": 1,
  "result": {
    "op": "string",
    "replacements": 1,
    "blocksInserted": 1,
    "blockIds": [
      "string"
    ],
    "trackedChangeIds": [
      "string"
    ]
  },
  "summary": {
    "paragraphCount": 1,
    "comments": 1,
    "trackedChanges": 1
  }
}
```

**SDK Code**

```python
import requests

url = "https://your-org.cloudraker.run/v2/redline/id/edits"

payload = {
    "anchorText": "string",
    "op": "string",
    "replacement": "string"
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://your-org.cloudraker.run/v2/redline/id/edits';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"anchorText":"string","op":"string","replacement":"string"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://your-org.cloudraker.run/v2/redline/id/edits"

	payload := strings.NewReader("{\n  \"anchorText\": \"string\",\n  \"op\": \"string\",\n  \"replacement\": \"string\"\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://your-org.cloudraker.run/v2/redline/id/edits")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"anchorText\": \"string\",\n  \"op\": \"string\",\n  \"replacement\": \"string\"\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://your-org.cloudraker.run/v2/redline/id/edits")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"anchorText\": \"string\",\n  \"op\": \"string\",\n  \"replacement\": \"string\"\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://your-org.cloudraker.run/v2/redline/id/edits', [
  'body' => '{
  "anchorText": "string",
  "op": "string",
  "replacement": "string"
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://your-org.cloudraker.run/v2/redline/id/edits");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"anchorText\": \"string\",\n  \"op\": \"string\",\n  \"replacement\": \"string\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "anchorText": "string",
  "op": "string",
  "replacement": "string"
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://your-org.cloudraker.run/v2/redline/id/edits")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```